// Configuration for default components
Ext.Loader.setConfig( {
    enabled:true,
    paths: {
        'Ext': 'app',
        'App': 'app'
    }
} );

Ext.apply(Ext.Date, { defaultFormat: 'd/m/Y' });
Ext.apply(Ext.Ajax, { timeout: 30000 });

// Application
Ext.define('Application', {
    extend: 'Ext.app.Application',
    name: 'App',
    appFolder: 'app',
    autoCreateViewport: false,
    enableQuickTips: true,
    mixins: {
        observable: 'Ext.util.Observable'
    },
    controllers: [
        'Viewport',
        'Navigation',
        'Report',
        'viewer.Table',
        'viewer.Chart',
        'viewer.chart.Transformer',
        'Viewer'
    ],
    launch: function() {
        this.getController('Viewer').launch();
        this.callParent(arguments);
    }
} );

Ext.data.Connection.override({
    request: function(options){
        var me = this;
        if(options.url.indexOf('/cticonnect/')===0){
            var relativePath = '../';
            if (location.pathname.indexOf('cdrview/development') > -1){
                relativePath += '../';
            }            
            options.url = options.url.replace(/^\/cticonnect\//, relativePath );
        }
        return me.callOverridden(arguments);
    }
});

Ext.override(Ext.view.Table, {
    afterRender: function() {
        var me = this;

        me.callParent();
        me.mon(me.el, {
            scroll: me.fireBodyScroll,
            scope: me
        });

        //me.el.unselectable();
        me.attachEventsForFeatures();
    }
});