Ext.define('App.proxy.Filters', {
	extend: 'App.proxy.AbstractProxy',
	alias: 'proxy.filters',
	constructor	: function(config) {
		this.callParent(arguments);
	},
	read: function(operation, callback, scope) {
        var sql;

        sql = "SELECT * FROM `FILTERS` ORDER BY `NAME` ASC";

        // Prepare callback
        var controller = function(records) {
            var i, result, filters, reader;

            filters = new Array();

            for( i=0; i < records.length; i++ ) {
                filters.push( { id: records[i]['ID'], name: records[i]['NAME'], state: records[i]['STATE'] } );
            }

            reader = this.getReader();
            result = reader.read(filters);

            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        // Batch
        App.storage.Storage.batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            controller,
            this
        );
	},
	readCount: function() {
        var s = App.storage.Storage;
        var c = s.featchOne("SELECT COUNT(*) FROM `FILTERS`");

        return c;
	},
    create: function(operation, callback, scope) {
        var sql, i, name, state, keys, key, records, batches, record, result = new Array();

        var controller = function() {
            for( i=0; i < arguments.length; i++ ) {
                keys = arguments[i]['keys'];
                key = keys.pop();

                operation.records[i].set('id', key);
            }

            operation.setCompleted();
            operation.setSuccessful();

            Ext.callback(callback, scope || this, [operation]);
        }

        records = operation.records;
        batches = new Array();

        for( i=0; i < records.length; i++ ) {
            name = records[i].get('name');
            name = this.escape(name);
            state = records[i].get('state');
            state = this.escape(state);
            sql = "INSERT INTO `FILTERS` (`ID`, `NAME`, `STATE`) VALUES (NULL, "+ name +", "+ state +")";

            batches.push([App.storage.Storage.METHOD_EXECUTE, sql]);
        }

        batches.push(controller);
        batches.push(this);

        // Batch

        App.storage.Storage.batch.apply(App.storage.Storage, batches);
    },
    update: function(operation, callback, scope) {
        throw Error("Not implemented");
    },
    destroy: function(operation, callback, scope) {
        throw Error("Not implemented");
    },
    truncate: function() {
        var s = App.storage.Storage;
        s.execute("TRUNCATE TABLE `FILTERS`");

        return true;
    },
    sync: function(records) {
        var s = App.storage.Storage, q, i, id, name, state;

        for( i=0; i < records.length; i++ ) {
            id = records[i]['id'];
            name = this.escape(records[i]['name']);
            state = this.escape(records[i]['state']);

            q = "INSERT INTO `FILTERS` (`ID`, `NAME`, `STATE`) VALUES ("+ id +", "+ name +", "+ state +")"
            s.execute(q);
        }

        return true;
    }
});
