Ext.define('App.proxy.Tags', {
    extend: 'App.proxy.AbstractProxy',
    alias: 'proxy.tags',
    read: function(operation, callback, scope) {
        var sql = "SELECT * FROM `TAGS` ORDER BY `NAME` ASC";
        var controller = function(records) {
            var i, result, tags, reader;

            tags = new Array();

            for( i=0; i < records.length; i++ ) {
                tags.push( { id: records[i]['ID'], name: records[i]['NAME'] } );
            }

            reader = this.getReader();
            result = reader.read(tags);

            operation.setCompleted();
            operation.setSuccessful();

            Ext.apply(operation, { resultSet: result } );
            Ext.callback(callback, scope || this, [operation]);
        }

        this.getStorage().batch(
            [App.storage.Storage.METHOD_FETCH, sql],
            controller,
            this
        );
    },
    readCount: function(callback, scope) {
        scope = scope || this;

        var sql = "SELECT COUNT(*) FROM `TAGS`";
        var controller = function() {
            callback.apply(scope, arguments);
        }

        this.getStorage().fetchOneAsync(sql, controller);
    }
});
