Ext.define('App.view.bootstrap.ErrorUnSupportedBrowser', {
    extend: 'App.view.bootstrap.Notification',
    title: sprintf(
            _t('%(CDRView)s does not support your browser'),
            {CDRView:_t('CDR-View')}
           ),
    width: 560,
    constructor: function() {
        this.addEvents('try');
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        
        this.descriptionCt = Ext.create('Ext.container.Container', {
            renderTpl: [
                sprintf('<div class="w-boot-description">%(notification)s</div>', { notification : '' })
            ]
        });
        
        this.browsersCt = Ext.create('Ext.container.Container', {
            layout: 'hbox',
            height: 100,
            items: [
                {
                    xtype: 'container',
                    height: 100,
                    flex: 0.25,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/chrome.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://www.google.com/chrome/',
                                    html: 'Google Chrome'
                                }
                            }
                        }
                    ]
                },
                {
                    xtype: 'container',
                    flex: 0.25,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/firefox.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://www.mozilla.com/firefox/',
                                    html: 'Firefox 3.6+'
                                }
                            }
                        }
                    ]
                },
                /*{
                    xtype: 'container',
                    height: 100,
                    flex: 0.25,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/ie.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://windows.microsoft.com/en-US/internet-explorer/products/ie/home',
                                    html: 'Internet Explorer 7+'
                                }
                            }
                        }
                    ]
                },*/
                {
                    xtype: 'container',
                    height: 100,
                    flex: 0.25,
                    hidden: navigator.platform.indexOf('Win') !==-1,
                    items: [
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'img',
                                    src: 'misc/icons/safari.png'
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            style: 'text-align: center;',
                            items: {
                                xtype: 'container',
                                autoEl: {
                                    tag: 'a',
                                    href: 'http://www.apple.com/safari/download/',
                                    html: 'Safari'
                                }
                            }
                        }
                    ]
                }
            ]
        });
        
        this.tryButton = Ext.create('Ext.button.Button', {
            hidden: true,
            align: 'right'
        });
        this.tryButton.on('click', this.onTryButtonClick, this);
        
        this.tryCt = Ext.create('Ext.container.Container', {
            layout: {
                type: 'auto'
            },
            items: [
                this.tryButton
            ]
        });
        
        this.containerCt = Ext.create('Ext.container.Container', {
            renderTo: this.formEl,
            padding: '5 0 0 0',
            items: [
                this.descriptionCt,
                this.browsersCt,
                this.tryCt
            ]
        });
    },
    onTryButtonClick: function() {
        this.fireEvent('try');
    }
} );
