Ext.define('App.view.filter.BillEditor', {
    extend: 'App.view.filter.MinMaxEditor',
    mark: _t('Talk time'),
    getBillDescription: function(state) {
        var s = state;

        if( s['leftEnabled'] && s['rightEnabled'] ) {
            return sprintf(_t('%(lvalue)s < Talk time < %(rvalue)s'), { lvalue : s['leftValue'], rvalue: s['rightValue']});
        } else if ( s['leftEnabled'] ) {
            return sprintf(_t('Talk time > %(value)s'), { value : s['leftValue'] });
        } else if ( s['rightEnabled'] ) {
            return sprintf(_t('Talk time < %(value)s'), { value : s['rightValue'] });
        }

        return null;
    },
    getDescription: function(state) {
        var desc = this.getBillDescription(state);
        
        if (desc) {
            return sprintf('%(billDesc)s', {billDesc : desc});
        }
        
        return this.getAnyDescription();
    },
    
    getFieldDescription: function(state) {
        var desc = this.getBillDescription(state);
        
        if (desc) {
            return sprintf('%(billDesc)s', {billDesc : desc});
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getBillDescription(this.state);
        
        if (desc) {
            return desc;
        }
        
        return null;
    }
});
