Ext.define('App.view.filter.field.combo.AbstractPicker', {
    extend: 'Ext.container.Container',
    cls: 'w-dst-picker',
    layout: 'anchor',
    renderTo: Ext.getBody(),
    floating: true,
    height: 300,
    maxResultsHeight: 450,
    minResultsHeight: 150,
    expand: function() {
        if (this.rendered && !this.expanded) {
            
            Ext.EventManager.onWindowResize(this.alignPicker, this);
            
            this.show();
            this.alignPicker();
            this.expanded = true;

            this.listCmp.refresh();
        }
    },
    collapse:function() {
        Ext.EventManager.removeResizeListener(this.alignPicker, this);
        
        this.hide();
        this.expanded = false;
    },
    realign: function() {
        var left = this.fieldEl.getLeft();
        var top = this.fieldEl.getTop() + this.fieldEl.getHeight();
        
        this.setWidth(this.fieldEl.getWidth());
        this.setPosition(left, top);
    },
    alignPicker: function() {
        var left = this.fieldEl.getLeft();
        var top = this.fieldEl.getTop() + this.fieldEl.getHeight();
        
        this.setWidth(this.fieldEl.getWidth());
        this.setHeight(this.getPickerHeight());
        this.setPosition(left, top);
    },
    alignPickerHeight: function() {
        this.setHeight(this.getPickerHeight());
    },
    getPickerHeight: function() {
        var height = 0;
        
        if (this.store.getTotalCount() == 0) {
            height += this.searchCmp.getHeight();
            height += this.listCmp.getNotifyHeight();
        } else {
            height += this.searchCmp.getHeight();
            height += this.listCmp.getResultsHeight();
            
            if (height > this.maxResultsHeight) {
                var bodedHeight = Ext.getBody().getHeight() - (this.fieldEl.getTop() + this.fieldEl.getHeight()) - this.getBodyBottomOffet();
                
                if (this.maxResultsHeight < bodedHeight) {
                    height = this.maxResultsHeight;
                } else if(this.minResultsHeight > bodedHeight) {
                    height = this.minResultsHeight;
                } else {
                    height = bodedHeight;
                }
            }
        }
        
        return height;
    },
    getBodyBottomOffet: function() {
        return 55;
    }
} );