Ext.define('App.view.navigation.Informer', {
    extend: 'Ext.view.View',
    alias: 'widget.navigationInformer',
    cls: 'w-navigation-informer',
    width: 277,
    initComponent: function() {

        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                'indent',
                'width'
            ]
        });

        this.tpl = new Ext.XTemplate(
            '<tpl for=".">',
                '<div class="inf-bar-item"  style="margin-left:{indent}px; width: {width}px; background-position-x:-{indent}px;" >',
                '</div>',
            '</tpl>'
        );

        this.itemSelector = 'div.inf-bar-item';


        this.callParent(arguments);
    },
    afterRender: function() {
        var me = this;
        this.tip = Ext.create('Ext.tip.ToolTip', {
            target: this.el,
            delegate: this.itemSelector,
            trackMouse: true,
            renderTo: Ext.getBody(),
            listeners: {
                beforeshow: function updateTipBody(tip) {
                    tip.update(
                        me.getRecord(tip.triggerElement).get('minDate')+ 
                        ' '  +
                        me.getRecord(tip.triggerElement).get('maxDate')
                    );
                }
            }
        });
        this.callParent(arguments);
    },

    drawBar: function(range, min, max) {
        var coef = this.width / (max - min),
            data = new Array;
console.debug('>>>>>>>>>>>> drawBar range', range , min, max);
console.debug('>>>>>>>>>>>> drawBar coef', coef);
        for(var i=0; i < range.length; i++) {
            var width = Math.ceil( (range[i].maxId - range[i].minId) * coef );
            var indent = Math.ceil( (range[i].minId - min) * coef );
            data.push({
                indent: indent,
                width: width,
                minDate: Ext.Date.dateFormat(Ext.Date.parse(range[i].minDate, 'Y-m-d'), 'd/m/Y'),
                maxDate: Ext.Date.dateFormat(Ext.Date.parse(range[i].maxDate, 'Y-m-d'), 'd/m/Y')
            });
        }

        this.store.loadData(data);
    }
    
} );