/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.ColumnChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    /*It should be here because otherwise there are mirror columns are shown*/
    shadow: false,

    createSeries: function(fields, pointsCount) {
        var series = [],
            me = this,
            labelSize = 8;

        if (pointsCount){
            if (pointsCount <= 10)
                labelSize = 32;
            else if (pointsCount < 20)
                labelSize = 15;
            else if (pointsCount < 40)
                labelSize = 12;
            else
                labelSize = 8;
        }

        var elem = {
            type: 'column',
            axis: 'left',
            stacked: true,
            highlight: true,
            xField: fields.xGroupField,
            yField: fields.yFields,
            title: this.getFormattedLegend(),
            tips: this.createTip(),
            /*  ------Override------- */
            hideAll: function() {
                this.imposion = [];
                var axes = this.chart.axes;
                if (!isNaN(this._index)) {
                    if (!this.__excludes) {
                        this.__excludes = [];
                    }
                    this.__excludes[this._index] = true;
                    this.drawSeries();
                    axes.each(function(axis) {
                        axis.drawAxis();
                    });
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    if (!series.seriesIsHidden)
                        series.renderLabels();
                });
            },
            
            // @private show all markers
            showAll: function() {
                this.imposion = [];
                var axes = this.chart.axes;
                if (!isNaN(this._index)) {
                    if (!this.__excludes) {
                        this.__excludes = [];
                    }
                    this.__excludes[this._index] = false;
                    this.drawSeries();
                    axes.each(function(axis) {
                        axis.drawAxis();
                    });
                }
                this.chart.series.each(function(series, index){
                    series.hideLabels(index);
                });
                this.chart.series.each(function(series, index){
                    if (!series.seriesIsHidden)
                        series.renderLabels();
                });
            },
            hideLabels: function(index) {
                this.imposion = [];

                var labelsGroup = this.labelsGroup, len;
                if (labelsGroup) {
                    len = labelsGroup.getCount();
                    while (len-->index) {
                        labelsGroup.getAt(len).hide(true);
                    }
                }
            },
            /*  ------Override------- */
            label: {
                display: me.options.isLabelVisible?'center':'none',
                field: fields.yFields,
                renderer: function(v) {
                    if (!v)
                        return '';
                    else
                        return me._formatTipData(v);
                },
                orientation: 'horizontal',
                color: '#333',
                'text-anchor': 'middle',
                font: labelSize+'px Helvetica,sans-serif'
            }
        };
        series.push(elem);
        return series;
    },

    createAxes: function(fields) {
        var self = this;
        var axes = [];
        //TODO: set type check
        var axeVals = {
            type: 'Numeric',
            position: 'left',
            fields: fields.yFields,
            title: false,
            minimum: 0,
            grid: true
        };
        axes.push(axeVals);

        //TODO: set type check
        var axeGrouping = {
            type: 'Category',
            position: 'bottom',
            fields: [fields.xGroupField],
            title: false,
            label: {
                rotate: {
                    degrees: 315
                },
                renderer: function(name) {
                    return self.getFormattedField(name);
                }
            }
        };
        axes.push(axeGrouping);
        return axes;
    }

});