/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.LineChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    legend: {
        position: 'right'
    },
    options: false,

    checkPossibilityToDraw: function() {
        var draw = true;
        var drawReason = "";
        console.log("LENNNNNNNN");
        console.log(this.options.records.length);
        if (this.options.records.length < 2) {
            draw = false;
            drawReason = "NO_DATA";
        }

        this.options.draw = draw;
        this.options.drawReason = drawReason;
    },

    createSeries: function(fields, pointsCount) {
        var series = [],
            me = this;
        for (var i in fields.yFields) {
            var elem = {
                type: 'line',
                axis: 'left',
                xField: fields.xGroupField,
                yField: fields.yFields[i],
                markerConfig: {
                    type: 'cross',
                    size: 4,
                    radius: 4,
                    'stroke-width': 0
                },
                tips: this.createTip(fields.yFields[i]),
                title: App.utility.NamesFormatter.formatText(fields.yFields[i]),

                onCreateLabel: function(storeItem, item, i, display) {
                    var me = this,
                    group = me.labelsGroup,
                    config = me.label,
                    bbox = me.bbox,
                    endLabelStyle = Ext.apply(config, me.seriesLabelStyle);
                    return me.chart.surface.add(Ext.apply({
                        'type': 'text',
                        'text-anchor': 'middle',
                        'group': group,
                        'x': item.point[0],
                        'y': bbox.y + bbox.height / 2
                    }, endLabelStyle || {}));
                },
                onPlaceLabel: function(label, storeItem, item, i, display, animate) {
                    var me = this,
                        chart = me.chart,
                        resizing = chart.resizing,
                        config = me.label,
                        format = config.renderer,
                        field = config.field,
                        bbox = me.bbox,
                        x = item.point[0],
                        y = item.point[1],
                        radius = item.sprite.attr.radius,
                        bb, width, height;

                    label.setAttributes({
                        text: format(storeItem.get(field)),
                        hidden: true
                    }, true);
                    if (me.seriesIsHidden)
                        return;
                    
                    label.setAttributes({
                        'text-anchor': 'start',
                        'rotation': {
                            x: x,
                            y: y,
                            degrees: display == 'rotate'?-45:0
                        }
                    }, true);
                    //correct label position to fit into the box
                    bb = label.getBBox();
                    width = bb.width;
                    height = bb.height;
                    x = x < bbox.x? bbox.x : x;
                    x = (x + width > bbox.x + bbox.width)? (x - (x + width - bbox.x - bbox.width) -(-5) ) : x-(-5);
                    y = (y - height < bbox.y)? bbox.y + height : y;

                    //Check for overlap
                    if (!chart.imposion)
                         chart.imposion = [];
                    x = parseFloat(x);
                    y = parseFloat(y);
                    var isOverlap = false;
                    for (var i = 0; i<chart.imposion.length; i++){
                        if (
                                (x < chart.imposion[i][0] + chart.imposion[i][2]) && (x+bb.width > chart.imposion[i][0])
                                &&
                                (y < chart.imposion[i][1] + chart.imposion[i][3]) && (y+bb.height > chart.imposion[i][1])
                           ){
                            isOverlap = true;
                        }
                    }

                    if (!isOverlap)
                        chart.imposion.push([x,y,bb.width,bb.height])

                    if (me.chart.animate && !me.chart.resizing) {
                        if (!isOverlap)
                        label.show(true);
                        me.onAnimate(label, {
                            to: {
                                x: x,
                                y: y
                            }
                        });
                    } else {
                        label.setAttributes({
                            x: x,
                            y: y
                        }, true);
                        if (!isOverlap)
                        label.show(true);

                    }
                    
                },
                showAll: function() {
                    this.toggleAll(true);
                    this.chart.series.each(function(series, index){
                        series.hideLabels(index);
                    });
                    this.chart.imposion = [];
                    this.chart.series.each(function(series, index){
                        if (!series.seriesIsHidden)
                            series.renderLabels();
                    });
                },
                hideAll: function() {
                    this.toggleAll(false);
                    this.chart.series.each(function(series, index){
                        series.hideLabels(index);
                    });
                    this.chart.imposion = [];
                    this.chart.series.each(function(series, index){
                        if (!series.seriesIsHidden)
                            series.renderLabels();
                    });
                },
                hideLabels: function(index) {

                    var labelsGroup = this.labelsGroup, len;
                    if (labelsGroup) {
                        len = labelsGroup.getCount();
                        while (len-->index) {
                            labelsGroup.getAt(len).hide(true);
                        }
                    }
                },
                label: {
                    display: me.options.isLabelVisible?'under':'none',
                    field: fields.yFields[i],
                    renderer: function(v) {
                        if (!v)
                            return '';
                        else
                            return me._formatTipData(v);
                    },
                    orientation: 'horizontal',
                    color: '#333',
                    'text-anchor': 'middle',
                    font: '8px Helvetica,sans-serif'
                }
            };
            series.push(elem);
        }
        return series;
    },
    getMaxGutter: function() {
        var me = this,
            maxGutter = [0, 0];
        me.series.each(function(s) {
            var gutter = s.getGutters && s.getGutters() || [0, 0];
            maxGutter[0] = Math.max(maxGutter[0], gutter[0]);
            maxGutter[1] = Math.max(maxGutter[1], gutter[1]);
        });
        me.maxGutter = maxGutter;
        me.imposion = [];
    },
    refresh: function() {
        var me = this;
        if (me.rendered && me.curWidth != undefined && me.curHeight != undefined) {
            if (me.fireEvent('beforerefresh', me) !== false) {
                me.redraw();
                me.fireEvent('refresh', me);
            }
        } else {
            setTimeout(function(){
                if (me.rendered && me.curWidth != undefined && me.curHeight != undefined){
                    me.redraw();
                }
            },200);
        }
    },
    createAxes: function(fields) {
        var self = this;
        var axes = [];
        //TODO: set type check: Time, Number or Category
        var axeVals = {
            type: 'Numeric',
            minimum: 0,
            position: 'left',
            fields: fields.yFields,
            title: false
        };
        axes.push(axeVals);

        //TODO: set type check: Time, Number or Category
        var axeGrouping = {
            type: 'Category',
            position: 'bottom',
            fields: fields.xGroupField,
            title: false,
            label: {
                rotate: {
                    degrees: 315
                },
                renderer: function(name) {
                    return self.getFormattedField(name);
                }
            }
        };
        axes.push(axeGrouping);

        return axes;
    },

    createTip: function(yField) {
        var self = this;
        var tip = {
            trackMouse: true,
            minWidth: 250,
            renderer: function(storeItem, item) {
                var title = App.utility.NamesFormatter.formatText(yField);
                var itemVal = self._formatTipData(storeItem.get(yField));
                var tooltip = self.getFormattedField(storeItem.get(self.options.fields.xGroupField)) + ' <br/> ' + itemVal;
                this.setTitle(title);
                this.update(tooltip);
            }
        };
        return tip;

    }

});