Ext.define('App.view.viewer.error.NotChosenGrouping', {
    extend: 'Ext.container.Container',
    layout: {
        type: 'vbox',
        align : 'stretch'
    },
    constructor: function() {
        this.callParent(arguments);
        this.addEvents('action');
        this.enableBubble('action');
    },
    initComponent: function() {

        this.tpl = new Ext.XTemplate(
            '<ul class="e-offers-list">',
                '<tpl for=".">',
                    '<li>',
                        '<a class="e-offers-list-link" name="{name}">{text}</a>',
                    '</li>',
                '</tpl>',
            '</ul>'
        );

        this.items = [
            {
                xtype: 'container',
                flex: 1
            },
            {
                xtype: 'container',
                layout: 'column',
                items: [
                    {
                        xtype: 'container',
                        cls: 'w-error-title',
                        style: 'text-align: right;',
                        columnWidth: 0.5,
                        html: _t('Please select a grouping from this list:')
                    },
                    {
                        xtype: 'container',
                        padding: '0 0 0 10',
                        columnWidth: 0.5,
                        cls: 'w-error-grouping-list'
                    }
                ]
            },
            {
                xtype: 'container',
                flex: 1
            }
        ];
        this.groupColumns = [
               { id: '1', name: 'HOUR', text: _t('Hour'), group: 'default' },
               { id: '1', name: 'HOUR_OF_DAY', text: _t('Hour of day'), group: 'default' },
               { id: '2', name: 'DAY', text: _t('Day'), group: 'default' },
               { id: '3', name: 'DAY_OF_WEEK', text: _t('Day of week'), group: 'default' },
               { id: '16',name: 'WEEK', text: _t('Week'), group: 'default' },
               { id: '4', name: 'MONTH', text: _t('Month'), group: 'default' },
               { id: '4', name: 'MONTH_OF_YEAR', text: _t('Month of year'), group: 'default' },
               { id: '5', name: 'YEAR', text: _t('Year'), group: 'default' },
               { id: '6', name: 'USER', text: _t('User'), group: 'default' },
               { id: '7', name: 'GROUP', text: _t('Group'), group: 'default' },
               { id: '8', name: 'CLIENT', text: _t('Business partner'), group: 'default' },
               { id: '9', name: 'COMPANY', text: _t('Company'), group: 'default' },
               { id: '10', name: 'NUMBER', text: _t('Number'), group: 'default' },
               { id: '11', name: 'TRUNK', text: _t('Trunk'), group: 'default' },
               { id: '14', name: 'TAG', text: _t('Tag'), group: 'default' },
               { id: '12', name: 'COUNTRY', text: _t('Country'), group: 'default' },
               { id: '13', name: 'CLASS', text: _t('Class'), group: 'default' }
           ]

        this.callParent(arguments);
    },

    afterRender: function() {
        this.callParent(arguments);

        this.periodEl = this.getEl().down('div.w-error-grouping-list');
        this.printOffersList(this.groupColumns);
        this.linkEl = this.getEl().down('.e-offers-list');
        this.linkEl.on('click', this.onLinkClick, this);

    },

    onLinkClick: function(e) {
        var targetName = e.getTarget().getAttribute('name');
        if(targetName) {
            this.fireEvent('action', this, 'groupingclick', [targetName]);
        }
    },

    printOffersList: function(offers) {
        this.tpl.overwrite(this.periodEl, offers);
    }
});