Ext.define('App.view.viewer.table.Scroller', {
    extend: 'Ext.grid.PagingScroller',
    alias: 'widget.viewerTableScroller',
    onGuaranteedRange: function(range, start, end) {
        var me = this,
            ds = me.store;

        if (range.length && me.visibleStart < range[0].index) {
            return;
        }

        ds.loadRecords(range);

        if (!me.firstLoad) {
            if (me.rendered) {
                me.invalidate();
            } else {
                me.on('afterrender', me.invalidate, me, {single: true});
            }
            me.firstLoad = true;
        } else {
            if (me.scrollEl && me.scrollEl.dom && me.scrollEl.dom.scrollHeight) {
                me.syncTo();
            }
        }
    },
    reconfigure: function(store) {
        if (this.store) {
            this.store.un('guaranteedrange', this.onGuaranteedRange, this);
        }
        
        this.store = store;
        this.store.on('guaranteedrange', this.onGuaranteedRange, this);
    },
    setViewScrollTop: function(scrollTop, useMax) {
        var owner = this.getPanel(),
            items = owner.query('tableview'),
            i = 0,
            len = items.length,
            center,
            centerEl,
            calcScrollTop,
            maxScrollTop,
            scrollerElDom = this.el.dom;

        owner.virtualScrollTop = scrollTop;

        center = items[1] || items[0];
        centerEl = center.el.dom;

        maxScrollTop = ((owner.store.pageSize * this.rowHeight) - centerEl.clientHeight);
        calcScrollTop = (scrollTop % ((owner.store.pageSize * this.rowHeight) + 1));
        if (useMax) {
            calcScrollTop = maxScrollTop;
        }
        if (calcScrollTop > maxScrollTop) {
            return;
        }
        for (; i < len; i++) {
            items[i].el.dom.scrollTop = calcScrollTop||0;
        }
    }
});
