Ext.define('App.view.viewport.Button', {
    extend: 'Ext.Container',
    alias : 'widget.viewportButton',
    cls: 'w-button',
    text: 'Viewport Button',
    hideMode: 'display',
    constructor: function() {
        this.addEvents('click');
        this.callParent(arguments);
    },
    initComponent: function() {
        this.renderTpl = [
            '<div class="w-button-left"><div class="w-button-right">',
                '{text}',
            '</div></div>'
        ];
        this.renderData = {
            text: this.text
        }
        this.renderSelectors = {
            textEl: 'div.w-button-right'
        }
        this.callParent(arguments);
    },
    setText: function(text) {
        this.text = text;
        this.textEl.update(text);
    },
    getText: function() {
        return this.text;
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEl().on('click', this.onClick, this);
    },
    onClick: function() {
        this.fireEvent('click');
    }
});
