Ext.define('App.view.viewport.error.ErrorCritical', {
    extend: 'Ext.Container',
    cls: 'w-boot-dialog w-viewport-critical',
    floating: true,
    width: 560,
    ariaRole: 'dialog',
    response: '-',
    title: _t('Error'),
    initComponent: function() {
        this.renderTo = Ext.getBody();
        Ext.getBody().query('.w-boot-dialog').forEach(function(el){
            if (el && el.id && Ext.ComponentManager.get(el.id)){
                Ext.ComponentManager.get(el.id).destroy();
            }
        });
        this.renderTpl = [
            '<div class="w-boot-title">{title}</div>',
            '<div class="w-boot-contents" style="padding: 5px 0 0 0;">',
                '<div class="w-boot-critical">{response}</div>',
                '<div>',
                    sprintf('%(criticalErr)s', { criticalErr : _t('Please <a href="javascript:location.reload(true)">reload</a> the page. If the problem persists contact your system administrator.') }),
                '</div>',
            '</div>'
        ];
        this.renderData = {
            title: this.title,
            response: this.response
        }
                
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.show();
    },
    destroy: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        this.callParent(arguments);
    },
    show: function() {
        Ext.EventManager.onWindowResize(this.align, this);

        // Mask body
        this.bodyMask = Ext.getBody().mask();
        this.bodyMask.setStyle('z-index', 99000);

        this.align();
        this.callParent(arguments);

        // Define a maximal z-index
        this.getEl().setStyle('z-index', 100000);
    },
    hide: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        Ext.getBody().unmask();

        this.callParent(arguments);
    },
    align: function() {
        var width = Ext.getBody().getWidth();
        var height = Ext.getBody().getHeight();
        var left = parseInt(width / 2) - parseInt(this.getWidth() / 2);
        var top = parseInt(height / 2) - parseInt(this.getHeight() / 2);

        this.setPosition( left, top, false);
    }
});
